hdu 3724

开始学trie,在结构体里车初始化的时候写成了tire,找了好长时间bug,难受,特别注意这里sz代表的是第几个节点,而不是层数,不同的节点可以在同一层

#include <iostream>
#include <cstring>
#include <cstdio>
#include <algorithm>
using namespace std;
const int maxn=300000+10;
double hh[maxn];
int ans[maxn];
const int inf=0x3f3f3f3f;
struct Trie
{
    int sz;
    int ch[maxn][50],val[maxn];
    int idx(char cc) {return (cc-‘a‘);}
    Trie()
    {
        sz=1;
        memset(ch[0],0,sizeof(ch[0]));
    }
   void inset(string s,int v)
   {
       int u=0;
       for(int i=0;i<s.length();i++)
       {
           int c=idx(s[i]);
           if(!ch[u][c])//u代表的是第几个点,而不是第几层,同一层可能有编号各样的点,如2,4,6
           {
               memset(ch[sz],0,sizeof(ch[sz]));//新点的下一个点清空
               val[sz]=0;
               ch[u][c]=sz++;//指向下一个点
           }
           u=ch[u][c];
           ans[u]++;//能够走到这个点就++
       }
       val[u]=v;
   }
   int serch(string aa)
   {
      int u=0;
      for(int i=0;i<aa.length();i++)
      {
          int c=idx(aa[i]);
          if(!ch[u][c])
            return 0;
          else u=ch[u][c];
      }
      return ans[u];//有几个能走到u点的
   }
};
Trie tree;
int n,m;
int main()
{
      while(~scanf("%d%d",&n,&m)&&n&&m)
      {    int qq=0;
          memset(ans,0,sizeof(ans));
          for(int i=0;i<n;i++)
          {
              string a;
              cin >> a;
              tree.inset(a,0);
          }
          int tt;
        for(int j=0;j<m;j++)
        {  string ss="";
            scanf("%d",&tt);
           for(int k=0;k<tt;k++)
           {
                double maxi=0,mini=inf*1.0;
                for(int i=0;i<8;i++)
                {
                    scanf("%lf",&hh[i]);
                    maxi=max(hh[i],maxi);
                    mini=min(hh[i],mini);
                }
            double mid=(maxi+mini)/2.0;
            for(int i=0;i<8;i++)
            {
                if(hh[i]>mid)
                    hh[i]=1;
                else hh[i]=0;
            }
            int zz=0,pp=1;
            for(int i=7;i>=0;i--)
            {
                zz+=hh[i]*pp;
                pp=pp*2;
            }
            char mmp=(char)zz;
            ss+=mmp;
           }
           qq+=tree.serch(ss);
        }
         printf("%d\n",qq);
      }
    return 0;
}
时间: 2024-08-10 19:18:42

hdu 3724的相关文章

HDU 3724 Encoded Barcodes (Trie)

题意:给n个字符串,给m个询问,每个询问给k个条形码.每个条形码由8个小码组成,每个小码有相应的宽度,已知一个条形码的宽度只有2种,宽的表示1,窄的表示0.并且宽的宽度是窄的宽度的2倍.由于扫描的时候有误差,每个小码的宽度为一个浮点型数据,保证每个数据的误差在5%内.所以一个条形码可以对应一个ASCC码,表示一个小写字母.k个条形码表示一个字符串s,每个询问表示给定的m个字符串中以s为前缀的字符串个数. 析:很容易看起来是Tire树, 不知道能不能暴过去,我觉得差不多可以,主要是在处理浮点数上,

HDU 3724 字典树

Encoded Barcodes Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1644    Accepted Submission(s): 569 Problem Description All the big malls need a powerful system for the products retrieval. Now

hdu 5641 King&#39;s Phone(暴力模拟题)

Problem Description In a military parade, the King sees lots of new things, including an Andriod Phone. He becomes interested in the pattern lock screen. The pattern interface is a 3×3 square lattice, the three points in the first line are labeled as

HDU 6203 ping ping ping [LCA,贪心,DFS序,BIT(树状数组)]

题目链接:[http://acm.hdu.edu.cn/showproblem.php?pid=6203] 题意 :给出一棵树,如果(a,b)路径上有坏点,那么(a,b)之间不联通,给出一些不联通的点对,然后判断最少有多少个坏点. 题解 :求每个点对的LCA,然后根据LCA的深度排序.从LCA最深的点对开始,如果a或者b点已经有点被标记了,那么continue,否者标记(a,b)LCA的子树每个顶点加1. #include<Bits/stdc++.h> using namespace std;

HDU 5542 The Battle of Chibi dp+树状数组

题目:http://acm.hdu.edu.cn/showproblem.php?pid=5542 题意:给你n个数,求其中上升子序列长度为m的个数 可以考虑用dp[i][j]表示以a[i]结尾的长度为j的上升子序列有多少 裸的dp是o(n2m) 所以需要优化 我们可以发现dp的第3维是找比它小的数,那么就可以用树状数组来找 这样就可以降低复杂度 #include<iostream> #include<cstdio> #include<cstring> #include

hdu 1207 汉诺塔II (DP+递推)

汉诺塔II Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 4529    Accepted Submission(s): 2231 Problem Description 经典的汉诺塔问题经常作为一个递归的经典例题存在.可能有人并不知道汉诺塔问题的典故.汉诺塔来源于印度传说的一个故事,上帝创造世界时作了三根金刚石柱子,在一根柱子上从下往

[hdu 2102]bfs+注意INF

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=2102 感觉这个题非常水,结果一直WA,最后发现居然是0x3f3f3f3f不够大导致的--把INF改成INF+INF就过了. #include<bits/stdc++.h> using namespace std; bool vis[2][15][15]; char s[2][15][15]; const int INF=0x3f3f3f3f; const int fx[]={0,0,1,-1};

HDU 3555 Bomb (数位DP)

数位dp,主要用来解决统计满足某类特殊关系或有某些特点的区间内的数的个数,它是按位来进行计数统计的,可以保存子状态,速度较快.数位dp做多了后,套路基本上都差不多,关键把要保存的状态给抽象出来,保存下来. 简介: 顾名思义,所谓的数位DP就是按照数字的个,十,百,千--位数进行的DP.数位DP的题目有着非常明显的性质: 询问[l,r]的区间内,有多少的数字满足某个性质 做法根据前缀和的思想,求出[0,l-1]和[0,r]中满足性质的数的个数,然后相减即可. 算法核心: 关于数位DP,貌似写法还是

HDU 5917 Instability ramsey定理

http://acm.hdu.edu.cn/showproblem.php?pid=5917 即世界上任意6个人中,总有3个人相互认识,或互相皆不认识. 所以子集 >= 6的一定是合法的. 然后总的子集数目是2^n,减去不合法的,暴力枚举即可. 选了1个肯定不合法,2个也是,3个的话C(n, 3)枚举判断,C(n, 4), C(n, 5) #include <bits/stdc++.h> #define IOS ios::sync_with_stdio(false) using name